using System;
using System.Text;
using System.Web;
using System.Web.Script.Serialization;
public partial class account : System.Web.UI.Page
{
  protected String sContents = "";
  protected void Page_Load(object sender, EventArgs e)
  {
    String sInitTok = Request.QueryString["InitTok"];
    if (sInitTok!=null)
    {
      Session["Env"] = Request.QueryString["Env"];
      Session["InitTok"] = sInitTok;
    }
    String sSubmited = Request.Form["submit"];
    if ( ((((String)Session["InitTok"])!=null) && (((String)Session["InitTok"])!="") )||((Session["PasswdIsExpired"]!=null) && ((bool)Session["PasswdIsExpired"]==true)))
    {
      String sError = "", sPasswdInfo = "", sSecQuests = "";
      Boolean bLoggable = false;
      if (sSubmited == "Login")
      {
        if ((Request.Form["password1"] == Request.Form["password2"]))
        {
          if ((Request.Form["password1"].Length > 0) && (Request.Form["SecQuest"].Length > 0) && (Request.Form["Answer"].Length > 0))
          {
            StringBuilder sb = new StringBuilder();
            sb.Append("{");
            sb.Append("\"cmd\"");
            sb.Append(":\"");
            sb.Append("ExecAccountInit");
            sb.Append("\",\"");
            sb.Append("Password");
            sb.Append("\":\"");
            sb.Append(Request.Form["password1"]);
            sb.Append("\",\"");
            sb.Append("SecQuest");
            sb.Append("\":\"");
            sb.Append(Request.Form["SecQuest"]);
            sb.Append("\",\"");
            sb.Append("SecAns");
            sb.Append("\":\"");
            sb.Append(Request.Form["Answer"]);
            sb.Append("\",\"");
            if (Session["InitTok"] != null)
            {
              sb.Append("InitTok");
              sb.Append("\":\"");
              sb.Append(((String)Session["InitTok"]).Substring(4));
              sb.Append("\",\"");
            }
            else if (Session["_AuthToken"]!=null)
            {
              sb.Append("AuthToken");
              sb.Append("\":\"");
              sb.Append(((String)Session["_AuthToken"]));
              sb.Append("\",\"");
            }
            sb.Append("ContextHash");
            sb.Append("\":\"");
            sb.Append(Utilities.SHA256Encrypt(Session["Env"] + Request.ServerVariables["HTTP_USER_AGENT"]));
            sb.Append("\"}");
            String sJson = sb.ToString();
            String sSecInfoJson = Utilities.callMegaSiteProvider("macro", "env=" + Session["Env"] + "&macro=" + Settings.PASSWORD_MACRO_ID, sJson);
            JavaScriptSerializer jss = new JavaScriptSerializer();
            try
            {
              dynamic data = jss.Deserialize<dynamic>(sSecInfoJson);
              sError = data["Error"];
              if (sError == "")
              {
                Response.Cookies["AuthToken"].Value = ((String)data["AuthToken"]).Substring(4);
                Response.Cookies["AuthToken"].HttpOnly = true;
                if (HttpContext.Current.Request.IsSecureConnection)
                {
                  Response.Cookies["AuthToken"].Secure = true;
                }
                Session["PasswdIsExpired"] = false;
                Session["InitTok"] = null;
                bLoggable = true;
              }
            }
            catch (Exception ex)
            {
              sError = "Failed to activate account:<br/>" + ex.Message + " (" + sSecInfoJson + ")";
            }
          }
          else
          {
            sError = "All fields are mandatory.";
          }
        }
        else
        {
          sError = "Passwords do not match.";
        }
      }
      if (bLoggable)
      {
        Response.Redirect("login.aspx");
      }
      else
      {
        Boolean bIsFatal = false;
        StringBuilder sb = new StringBuilder();
        sb.Append("{");
        sb.Append("\"cmd\"");
        sb.Append(":\"");
        sb.Append("GetSecInfo");
        sb.Append("\"}");
        String sJson = sb.ToString();
        String sSecInfoJson = Utilities.callMegaSiteProvider("macro", "env=" + Session["Env"] + "&macro=" + Settings.PASSWORD_MACRO_ID, sJson);
        JavaScriptSerializer jss = new JavaScriptSerializer();
        try
        {
          dynamic data = jss.Deserialize<dynamic>(sSecInfoJson);
          sPasswdInfo = data["PasswdInfo"] + "<br/>";
          dynamic SecQuests = data["SecQuests"];
          foreach (dynamic SecQuest in SecQuests)
          {
            sSecQuests += "<option value=\"" + SecQuest["Value"] + "\">" + SecQuest["Name"] + "</option>";
          }
        }
        catch (Exception ex)
        {
          sError = "Failed to get account activation information:<br/>" + ex.Message + " (" + sSecInfoJson + ")<br/>";
          bIsFatal = true;
        }
        if((Session["PasswdIsExpired"]!=null) && ((bool)Session["PasswdIsExpired"]==true) )
        {
          sContents += ("<h1 class=\"cadre\">Your password has expired</h1>");
        }
        else
        {
          sContents += ("<h1 class=\"cadre\">Account activation</h1>");
        }
        sContents += ("<div class=\"cadre\"><div class=\"error\">" + HttpUtility.HtmlEncode(sError) + "</div><div class=\"style1\">" + sPasswdInfo + "</div></div>");
        if (!bIsFatal)
        {
          sContents += ("<div class=\"cadre\"><form action=\"account.aspx\" method=\"post\" class=\"style1\"><span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:200px;\">Enter your password</span><input type=\"password\" name=\"password1\"><br/><span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:200px;\">Re-enter your password</span><input type=\"password\" name=\"password2\"><br/>");
          sContents += ("<span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:200px;\">Choose your security question</span><select name=\"SecQuest\" id=\"SecQuest\"/>" + sSecQuests + "</select><br/>");
          sContents += ("<span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:200px;\">Enter its answer</span><input type=\"password\" name=\"Answer\"><br/>");
          sContents += ("<input type=\"submit\" name=\"submit\" value=\"Login\" class=\"submit\"></form></div>");
        }
      }
    } 
    else 
    {
      sContents += ("<h1 class=\"cadre\">Lost password</h1><div class=\"cadre\">");
      if (sSubmited == "Continue")
      {
        String sError = "", sSecQuest="";
        StringBuilder sb = new StringBuilder();
        sb.Append("{\"");
        sb.Append("cmd");
        sb.Append("\":\"");
        sb.Append("GetUserQuest");
        sb.Append("\",\"");
        sb.Append("Login");
        sb.Append("\":\"");
        sb.Append(Request.Form["Login"]);
        sb.Append("\"}");
        String sJson = sb.ToString();
        String sSecInfoJson = Utilities.callMegaSiteProvider("macro", "env=" + Request.Form["Env"] + "&macro=" + Settings.PASSWORD_MACRO_ID, sJson);
        JavaScriptSerializer jss = new JavaScriptSerializer();
        try
        {
          dynamic data = jss.Deserialize<dynamic>(sSecInfoJson);
          sError = data["Error"] ;
          sSecQuest = data["SecQuest"];
        }
        catch (Exception ex)
        {
          sError = "Failed to get password recovery information:<br/>" + ex.Message + " (" + sSecInfoJson + ")<br/>";
        }
        sContents += "<div class=\"error\">" + HttpUtility.HtmlEncode(sError) + "</div>";
        if (sError == "")
        {
          sContents += ("<form action=\"account.aspx\" method=\"post\" class=\"style1\">");
          sContents += (sSecQuest + " <input type=\"password\" name=\"Answer\"><br/>");
          sContents += ("<input type=\"hidden\" name=\"Login\" value=\"" + Request.Form["Login"] + "\">");
          sContents += ("<input type=\"hidden\" name=\"Env\" value=\"" + Request.Form["Env"] + "\">");
          sContents += ("<input type=\"submit\" name=\"submit\" value=\"Reinitialize\" class=\"submit\"></form></div>");
        }
      }
      else if (sSubmited == "Reinitialize")
      {
        String sError = "";
        StringBuilder sb = new StringBuilder();
        sb.Append("{\"");
        sb.Append("cmd");
        sb.Append("\":\"");
        sb.Append("ExecPasswdRecovery");
        sb.Append("\",\"");
        sb.Append("Login");
        sb.Append("\":\"");
        sb.Append(Request.Form["Login"]);
        sb.Append("\",\"");
        sb.Append("SecAnswer");
        sb.Append("\":\"");
        sb.Append(Request.Form["Answer"]);
        sb.Append("\"}");
        String sJson = sb.ToString();
        String sSecInfoJson = Utilities.callMegaSiteProvider("macro", "env=" + Request.Form["Env"] + "&macro=" + Settings.PASSWORD_MACRO_ID, sJson);
        JavaScriptSerializer jss = new JavaScriptSerializer();
        try
        {
          dynamic data = jss.Deserialize<dynamic>(sSecInfoJson);
          sError = data["Error"];
        }
        catch (Exception ex)
        {
          sError = "Failed to get password recovery information:<br/>" + ex.Message + " (" + sSecInfoJson + ")";
        }
        if (sError == "")
        {
          sContents += "<span class=\"style1\">An e-mail has been sent to your adress with a link to re-activate your account.</span>";
        }
        else
        {
          sContents += "<div class=\"error\">" + HttpUtility.HtmlEncode(sError) + "</div>";
        }
      }
      else
      {
        sContents += ("<form action=\"account.aspx\" method=\"post\" class=\"style1\">");
        String sXMLEnvironments = Utilities.callMegaSiteProvider("env", "", "");
        String sEnv = null;
        String sLastEnv = "";
        if (Request.Cookies[Settings.APP_ACCESS+"lastCnx"] != null)
        {
          sLastEnv = Request.Cookies[Settings.APP_ACCESS + "lastCnx"]["LastEnv"];
        }
        String sEnvList = null;
        String sRes = Utilities.BuildSelects(sXMLEnvironments, "Environment", ref sEnvList, ref sEnv, sLastEnv);
        if (sRes != null)
        {
          sContents += "<div class=\"error\">" + sRes + "</div>";
        }
        else if (sEnvList == null)
        {
          sContents += ("<input type=\"hidden\" name=\"Env\" id=\"Env\"/ value=\"" + sEnv + "\"></input>");
        }
        else
        {
          sContents += ("<span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:80px;\">Environment</span><select name=\"Env\" id=\"Env\"/>" + sEnvList + "</select><br/>");
        }
        sContents += ("<span class=\"label\" style=\"display:inline-block;font-weight:bold;height:20px;width:80px;\">Login</span><input name=\"login\"><br/>");
        sContents += ("<input type=\"submit\" name=\"submit\" value=\"Continue\" class=\"submit\"></form></div>");
      }
    }
  }
}
