<%@ Page Language="C#" AutoEventWireup="true" Trace="true" CodeFile="mega_sys_info.aspx.cs" Inherits="mega_sys_info" %>
<% if (!m_bReportDumped) { %>
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
      
      <title>MEGA System Web Report</title>
      <link rel="shortcut icon" type="images/x-icon" href="images/favicon.ico"/>
      
      <% 
      Settings settings = ((Settings)Application.Get("SETTINGS"));
      Utilities.includeJSFrameworks(settings,Response, null, "../"); 
      %>


      
        <style type="text/css">
          body { font-family:Verdana,Arial,Helvetica,sans-serif;
                 font-size: 10pt;
                 padding: 10px 10px 10px 10px }
          h1 {  color: #213487;
                font-size: 18pt;
                text-align: center;
                margin-bottom: 10px; }
          h2 {  color:#213487;
                font-size:12pt;
                font-weight:bold;
                margin-top: 10px;
                margin-bottom: 5px;
                text-align:left;
              }
          th { width: 150pt; }
          td { text-align: right;
               width: 100pt } 
          td.ok     {width: 20pt;
                     color:green;}
          td.failed {width: 20pt;
                     color:red; }
          form { text-align: center;
                 margin-top: 20pt; }
          input { visibility:hidden; }
        </style>
    
      <script type="text/javascript">
          var cfg = {
            bandwidthUrl    : 'bandwidth.aspx?iter=',
            tbBandwidthIter : [ 1500, 12700, 100000, 200000, 500000, 1000000 ],
            minFF           : <%= Settings.I_MIN_FF_VERSION %>,
            minIE           : <%= Settings.I_MIN_IE_VERSION %>,
            minChrome       : <%= Settings.I_MIN_CHROME_VERSION %>  ,
            minExtFF        : 2,
            minExtIE        : <%= Settings.I_MIN_IE_VERSION %>,

            minFlash        : {
                major  : 9,
                minor  : 0,
                release: 0},
            pingUrl         : 'ping.txt?',
            nbPing          : 10,
            pingResponse    : 'ACK',
            maxPing         : 130,
            minkBps         : 512
        };
      </script>

      <script type="text/javascript" src="mega_sys_info.js"></script>
      
    </head>
    <body>
      <div style="width:300pt; margin-left:auto; margin-right:auto">
        <h1>Collecting Client-Side Data</h1>
        <a id="forceLink" href="mega_sys_info.aspx?complete=forced" onclick="showPleaseWait">Click here to skip client-side data collection...</a>
        <p id="pleaseWait" style="visibility:hidden"><img style="float:left; margin-right:10px" src="../images/spinner.gif" />Your report is being generated. This may take a few minutes...</p>
      
        <div id="main">
          <h2>Browser</h2>
          <p>User Agent : <span id="useragent"></span></p>
          
          <table><tbody id="browser" /></table>
          
          <h2>Latency</h2>
          <table><tbody id="ping"/></table>

          <h2>Bandwith</h2>
          <table><tbody id="bandwith"/></table>
        </div>
          
        <form id="resPoster" action="mega_sys_info.aspx" method="POST">
          <input type="hidden" name="resJson" />
          <input type="hidden" name="complete" value="auto" />
        </form>
      </div>
      <div id="flashDetect"></div>
    
    </body>
  </html>
  <% // Ugly hack to hide the ASP trace %>
  <noscript>
<% } %>
